<!-- eslint-disable -->
<i18n>
{
  "de": {
    "category":"Kategorie",
    "state": "Status",
    "street": "Strasse, Hausnummer",
    "city": "PLZ, Ort",
    "constructed": "Erbaut",
    "demolished": "Abgerissen",
    "description": "Architektur",
    "moreinfo": "Abrissgrund",
    "comment": "Geschichten und Erinnerungen",
    "problem": "Fehler",
    "reportProblem": "Fehler melden",
    "emailOpener": "Bitte ändern Sie die untenstehenden Daten direkt:"
  },
  "fr": {
    "category":"Catégorie",
    "state": "Statut",
    "street": "Rue, numéro",
    "city": "Code postal, lieu",
    "constructed": "Construit",
    "demolished": "Arraché",
    "description": "Architecture",
    "moreinfo": "Cause de la démolition",
    "comment": "Histoires et souvenirs",
    "problem": "Erreur",
    "reportProblem": "Signaler une erreur",
    "emailOpener": "Veuillez modifier directement les données ci-dessous:"
  },
  "en": {
    "category":"Category",
    "state": "Status",
    "street": "Street, house number",
    "city": "Postcode, place",
    "constructed": "Built",
    "demolished": "Demolished",
    "description": "Architecture",
    "moreinfo": "Demolition reason",
    "comment": "Stories and memories",
    "problem": "Mistake",
    "reportProblem": "Report a mistake",
    "emailOpener": "Please change the data below inline:"
  },
  "it": {
    "category":"Categoria",
    "state": "Stato",
    "street": "Via, numero civico",
    "city": "Codice postale, luogo",
    "constructed": "Costruito",
    "demolished": "Abbattuto",
    "description": "Architettura",
    "moreinfo": "Motivo della demolizione",
    "comment": "Storie e ricordi",
    "problem": "Errore",
    "reportProblem": "Segnala un errore",
    "emailOpener": "Modificare direttamente i dati sottostanti:"
  }
}
</i18n>
<!-- eslint-enable -->

<template>
  <div>
    <v-fade-transition>
      <v-overlay v-if="curObj !== null" z-index="505">
        <div
          @click="$emit('close')"
          style="width: 100vw; height: 100vh; cursor: pointer;"
        ></div>
      </v-overlay>
    </v-fade-transition>
    <v-slide-x-transition>
      <div
        v-if="curObj !== null"
        id="objectDetail"
        class="pa-4 elevation-6"
      >
        <v-toolbar flat absolute class="toolbar">
          <v-spacer></v-spacer>
          <v-btn icon large @click="$emit('close')">
            <v-icon large>$vuetify.icons.close</v-icon>
          </v-btn>
        </v-toolbar>
        <div class="smaller">
          <div class="topContainer">
            <v-carousel v-if="curObj.attachements.length > 0"
              height="400px"
              :next-icon="$vuetify.icons.next"
              :prev-icon="$vuetify.icons.prev"
              hide-delimiters
              :show-arrows="curObj.attachements.length > 1"
              class="my-1"
              >
              <v-carousel-item eager v-for="(item, i) in curObj.attachements" :key="i"
                :src="assetBaseUrl + '/media/' + item.document"
                class="requestable-filter"
                contain></v-carousel-item>
            </v-carousel>

            <div class="objectTitle">
              <h3>{{ curObj.data.properties.title }}</h3>
              <h4>{{ curObj.data.properties.subtitle }}</h4>
            </div>
          </div>

          <v-container class="body-1 mainDetails">
            <v-row>
              <v-col class="reportProblem">
                <v-btn small text class="btn"
                  :href="`mailto:${mailLink}`">
                  {{ $t('reportProblem') }}
                </v-btn>
              </v-col>
            </v-row>
            <v-row class="objectData" v-if="curObj.category.name">
              <v-col class="px-0 py-0">
                <span>{{ $t('category') }}</span> {{ curObj.category.name }}
              </v-col>
            </v-row>
            <v-row class="objectData" v-if="curObj.data.properties.constructionYear">
              <v-col class="px-0 py-1">
                <span>{{ $t('constructed') }}</span> {{ curObj.data.properties.constructionYear }}
              </v-col>
            </v-row>
            <v-row class="objectData" v-if="curObj.data.properties.demolitionYear">
              <v-col class="px-0 py-1">
                <span>{{ $t('demolished') }}</span> {{ curObj.data.properties.demolitionYear }}
              </v-col>
            </v-row>
            <v-row class="objectData" v-if="curObj.data.properties.description">
              <v-col class="px-0 py-1">
                <span>{{ $t('description') }}</span> {{ curObj.data.properties.description }}
              </v-col>
            </v-row>
            <v-row class="objectData" v-if="curObj.data.properties.moreinfo">
              <v-col class="px-0 py-1">
                <span>{{ $t('moreinfo') }}</span> {{ curObj.data.properties.moreinfo }}
              </v-col>
            </v-row>
            <v-row v-if="curObj.category.commentsEnabled || curObj.data.properties.comment">
              <v-col class="px-0 py-0">
                <span>{{ $t('comment') }}</span>
              </v-col>
            </v-row>
            <v-row class="objectData" v-if="curObj.data.properties.comment">
              <v-col class="px-0 py-0">
                <span v-if="curObj.data.properties.commentAuthor">
                  {{ curObj.data.properties.commentAuthor }}
                </span> {{ curObj.data.properties.comment }}
              </v-col>
            </v-row>
            <v-row v-if="curObj.category.commentsEnabled">
              <v-col class="px-0 py-0">
                <div id="commento"></div>
              </v-col>
            </v-row>
          </v-container>
        </div>
      </div>
    </v-slide-x-transition>
  </div>
</template>

<style>
button svg {
  color: #212121;
}
button:hover::before {
  opacity: 0 !important;
}
button svg:hover {
  color: #B2B2B2;
}
.v-window__next, .v-window__prev {
  background-color: transparent !important;
}
.toolbar {
  width: 95%;
  background-color: transparent !important;
}
#objectDetail {
  position: fixed;
  top: 0em;
  left: 0;
  width: 50em;
  height: 100vh;
  background: #fff;
  z-index: 1100;
  overflow: auto;
}

.col.reportProblem {
  display: flex;
  justify-content: right;
  padding-right: 0;
  padding-left: 0;
}
a.btn.v-btn {
  border-bottom: 0.35em solid #212121;
  width: fit-content;
  border-radius: 0;
  padding: 0 !important;
  padding-bottom: 0.1em;
  margin-bottom: 0.5em;
  line-height: 0.5em;
  height: fit-content !important;
}
a.btn.v-btn:hover {
  color: #B2B2B2 !important;
  border-bottom-color: #B2B2B2;
}
a.btn.v-btn span:after {
  content: '';
}
a.btn.v-btn:hover::before {
  opacity: 0;
}

.topContainer h3, .topContainer h4 {
  font-size: 2.2em;
  font-family: 'Helvetica Neue LT W05 75 Bold', 'Arial', sans-serif !important;
  width: fit-content;
  line-height: 1em;
  text-transform: uppercase;
  border-bottom: 0.3em solid #000;
  margin-bottom: 0.4em;
}

.v-image__image {
    background-color: transparent !important;
    border: 0 !important;
}

.objectTitle {
  text-transform: uppercase;
  z-index: 1;
}

.topContainer {
  display: grid;
  align-items: start;
  justify-items: left;
}
.topContainer > * {
  grid-area: 1/1/1/1;
}
.requestable-filter {
  filter: grayscale(100%) brightness(110%);
  opacity: 1 !important;
}
.v-application .body-1 {
  font-family: 'Queue', sans-serif !important;
  font-weight: bold;
  font-size: 0.8rem !important;
  line-height: 1.5em;
}
.body-1 span {
  font-family: 'Helvetica Neue LT W05 75 Bold', 'Arial', sans-serif !important;
}
.body-1 span::after {
  content: ":";
}
.row.objectData {
  border-top: 1px solid black;
}
.mainDetails {
  border-bottom: 1px solid black;
}

#commento {
  margin-top: 12px;
}

@media (max-width: 600px) {
  #objectDetail {
    /* width: calc(100vw - 7em); */
    width: 100%;
  }
}
</style>

<script>
// import Vue from 'vue';

export default {
  name: 'ObjectDetail',
  data() {
    return {
      assetBaseUrl: process.env.VUE_APP_ASSETBASEURL,
      commentoUrl: process.env.VUE_APP_COMMENTO_URL || null
    };
  },

  props: {
    object: Object,
    enableLikes: Boolean
  },

  updated() {
    if (this.commentoUrl !== null && this.curObj.category.commentsEnabled) {
      if (typeof window !== 'undefined' && window.commento.main === undefined) {
        const commentoScript = document.createElement('script');
        commentoScript.setAttribute('src', `${this.commentoUrl}/js/commento.js`);
        commentoScript.setAttribute('data-auto-init', false);
        commentoScript.setAttribute('data-no-fonts', true);
        commentoScript.setAttribute('data-locale', this.$route.params.lang);
        commentoScript.setAttribute('data-page-id', `/map/${this.curObj.pk}/`);
        commentoScript.setAttribute('data-css-override', '/commento.css');
        commentoScript.setAttribute('data-hide-deleted', true);
        commentoScript.setAttribute('defer', true);
        document.head.appendChild(commentoScript);
        window.setTimeout(() => {
          window.commento.main();
        }, 700);
      } else if (typeof window !== 'undefined' && window.commento) {
        window.commento.reInit({
          pageId: `/${this.$route.params.wshash}/${this.curObj.pk}/`
        });
      }
    }
  },

  computed: {
    djangobaseurlDisplay() {
      return this.assetBaseUrl.replace('https://', '').replace('http://', '');
    },
    curObj() {
      if (this.object) {
        return this.object;
      }
      return null;
    },
    mailLink() {
      const toAddress = 'abriss@countdown2030.ch';
      const ccAddress = 'support@abriss-atlas.ch';
      const itemLink = `${process.env.VUE_APP_PUBLIC_URL}/${this.$i18n.locale}/map/${this.curObj.pk}/`;
      const subject = `${this.$t('problem')}: ${this.curObj.data.properties.title}, ${this.curObj.data.properties.subtitle} [${itemLink}]`;
      const body = `
${this.$t('emailOpener')}

${this.$t('street')}: ${this.curObj.data.properties.title}
${this.$t('city')}: ${this.curObj.data.properties.subtitle}
${this.$t('constructed')}: ${this.curObj.data.properties.constructionYear}
${this.$t('demolished')}: ${this.curObj.data.properties.demolitionYear}

${this.$t('description')}
${this.curObj.data.properties.description}

${this.$t('moreinfo')}
${this.curObj.data.properties.moreinfo}

For admins: other annotation details
Coordinates: ${this.curObj.data.geometry.coordinates[0]}, ${this.curObj.data.geometry.coordinates[1]}
URL: ${itemLink}
GeoAdmin: http://map.geo.admin.ch/?bgLayer=ch.swisstopo.pixelkarte-grau%26swisssearch=${this.curObj.data.geometry.coordinates[0]},${this.curObj.data.geometry.coordinates[1]}
ID: ${this.curObj.pk}
User locale: ${this.$i18n.locale}
Category: ${this.curObj.category.name} (${this.curObj.data.properties.other})
State: ${this.curObj.state.name}
`;
      return `${toAddress}?cc=${ccAddress}&subject=${encodeURI(subject)}&body=${encodeURI(body)}`;
    }
  }
};
</script>
